#!/usr/bin/env node

global.rootPath = __dirname;

const program = require('commander');
const updateNotifier = require('update-notifier');

const pkg = require('./package.json');
const newTask = require('./tasks/new');
const serveTask = require('./tasks/serve');

function start() {
  updateNotifier({ pkg }).notify();

  program
    .version(pkg.version)
    .description(pkg.description);

  program
    .command('new [name]')
    .description('Create new widget')
    .action(newTask);
  program
    .command('serve [path] [url]')
    .description('Preview and test your widget on any website')
    .action(serveTask);

  program.parse(process.argv);

  if (!process.argv.slice(2).length) {
    // Show help by default
    program.outputHelp();
  }
}

start();
