import babel from 'rollup-plugin-babel';
import eslint from 'rollup-plugin-eslint';
import uglify from 'rollup-plugin-uglify';
import resolve from 'rollup-plugin-node-resolve';
<% if (ui) { %>
import pug from 'rollup-plugin-pug';
import postcss from 'rollup-plugin-postcss';
import cssnext from 'postcss-cssnext';
import cssnano from 'cssnano';
<% } %>
import pkg from './package.json';

const plugins = [
  <% if (ui) { %>
  postcss({
    plugins: [
      cssnext(),
      cssnano({
        autoprefixer: false,
        zindex: false,
      }),
    ],
  }),
  pug(),
  <% } %>
  eslint({
    include: 'src/**/*.js',
  }),
  babel({
    include: 'src/**/*.js',
    exclude: 'node_modules/**',
  }),
  uglify(),
  resolve(),
];


export default [
  // Widget code MUST be IIFE format.
  {
    input: 'src/main.js',
    output: {
      file: pkg.main,
      format: 'iife',
    },
    plugins,
  },

  // Widget form MUST be UMD format.
  {
    input: 'src/form.js',
    output: {
      file: pkg.form,
      format: 'umd',
    },
    name: 'widgetForm',
    plugins,
  },
];
