import modal from './modal.pug';
import './main.css';

const container = document.createElement('abtasty-modal');

const addModalHTML = () => {
  container.className = 'abtasty-modal';
  // Get current test id with the `TEST_ID` global variable.
  // This only works on production. In developement, the value is always 1.
  container.dataset.testId = TEST_ID;
  // Get all the values from your form (form.js) with the `DATA` global variable.
  container.innerHTML = modal({ title: DATA.message });

  document.body.appendChild(container);
};

const hideModal = () => {
  container.style.display = 'none';
};

const addListenersForClose = () => {
  const underlay = container.querySelector('abtasty-modal__underlay');
  const closeButton = container.querySelector('.abtasty-modal__close');
  underlay.addEventListener('click', hideModal);
  closeButton.addEventListener('click', hideModal);
};

const showModal = () => {
  container.style.display = 'block';
  addListenersForClose();
};

const start = () => {
  addModalHTML();
  showModal();
};

start();
