const byID = id => document.getElementById(id);

class Constants {
  constructor() {
    this.PORTRAIT = 'portrait';
    this.LANDSCAPE = 'landscape';
    this.ACTIVE = 'active';
    this.CUSTOM = 'custom';
    this.ipcEvents = {
      selectElement: 'select-element',
      selectElementComplete: 'return-selector',
      loadWidget: 'loadWidget',
      loadWebpage: 'loadWebpage',
    };
    this.byID = id => document.getElementById(id);
  }

  get $WEBVIEW__WEBPAGE() {
    return byID('webpage-webview');
  }
  get $WEBVIEW__CONFIGFORM() {
    return byID('form-webview');
  }
  get $INPUT__WEBPAGE_URL() {
    return byID('url-input');
  }
  get $BTN__WEBPAGE_PREV() {
    return byID('prev');
  }
  get $BTN__WEBPAGE_NEXT() {
    return byID('next');
  }
  get $BTN__WEBPAGE_REFRESH() {
    return byID('refresh');
  }
  get $SELECT__WEBPAGE_RESIZE() {
    return byID('resizable_select');
  }
  get $INPUT__WEBPAGE_WIDTH() {
    return byID('device-width');
  }
  get $INPUT__WEBPAGE_HEIGHT() {
    return byID('device-height');
  }
  get $SPAN__ROTATE_BUTTONS() {
    return byID('rotate-buttons');
  }
  get $INPUT__WEBPAGE_ROTATE_PORTRAIT() {
    return byID('rotate-portrait');
  }
  get $INPUT__WEBPAGE_ROTATE_LANDSCAPE() {
    return byID('rotate-landscape');
  }
  get $INPUT__WEBPAGE_DEVTOOLS() {
    return byID('website-dev-tools');
  }
  get $INPUT__CONFIGFORM_DEVTOOLS() {
    return byID('form-dev-tools');
  }
  get $CONFIGFORM() {
    return document.querySelector('.configuration-form');
  }
  get $CONFIGFORM__TOGGLER() {
    return byID('form_toggle');
  }
}

module.exports = new Constants();
