const { getPosition } = require('../helpers');

class ElementSelector {
  constructor() {
    this.id = 'ABTastySelector';
  }

  get target() {
    return document.getElementById(this.id);
  }

  remove() {
    const elm = this.target;
    elm.parentNode.removeChild(elm);
  }

  append() {
    const element = document.createElement('div');
    document.body.appendChild(element);
    element.id = this.id;
    element.style.background = 'rgba(28,90,153,0.3)';
    element.style.outline = '2px solid #1c5a99';
    element.style.position = 'absolute';
    element.style.pointerEvents = 'none';
    element.style.zIndex = '999999999';
  }

  hover(e) {
    const T = this.target;
    T.style.width = `${e.target.offsetWidth}px`;
    T.style.height = `${e.target.offsetHeight}px`;
    const elmOffsetTop = getPosition('top', e.target);
    const elmOffsetLeft = getPosition('left', e.target);
    T.style.top = `${elmOffsetTop}px`;
    T.style.left = `${elmOffsetLeft}px`;
  }
}

module.exports = ElementSelector;
