// AB Tasty Form Parser
// For HTML forms only.
// /!\ WARNING: DEPRECATED /!\

/* global $ */

const pluginForm = 'form';
const $pluginForm = $(pluginForm);
const addElement = '[data-add-element]';
const addElementOld = '[pluginAddElement]';
const closeAddedElement = 'ab-embed-editor__plugin__close-added-element';

$(document)
    // .on('click', S.PLUGINS.selectElementBtn, S.PLUGINS.selectElement)
    .on('click',
        `${pluginForm  } ${ 
        addElement  },${ 
        pluginForm  } ${ 
        addElementOld}`,
        function () {
            const key = _getKeyFromElement($(this));
            _addElementToPluginForm(key);
        }
    )
		.on('click', `.${  closeAddedElement}`, _removeAddedElement)


function _getKeyFromElement($element) {
  let key;
  if ($element.data('addElement')) {
    key = $element.data('addElement');
  } else {
    key = $element.attr('pluginAddElement');
  }
  return key;
}

function _removeAddedElement() {
  $(this).parent().remove();
}

function _addElementToPluginForm(key) {
  const elementCloned = $(pluginForm)
    .find('.templates').find(`[pluginDataName="${  key  }"], [data-plugin-key="${  key  }"]`)
    .clone();
  elementCloned
    .append(`<a href="javascript:;" class="${  closeAddedElement  }">Remove</a>`);
  $(pluginForm)
    .find(`[pluginPlaceFor="${  key  }"], [data-plugin-place-for="${  key  }"]`)
    .append(elementCloned);
  return elementCloned;
}

function _parseTag(tag, hasAnInputChildren, inputsChildren) {
  const element = hasAnInputChildren ? inputsChildren : $(tag);
  const elementType = $(element).attr('type');
  if (elementType === 'radio' && !$(element).is(':checked')) {
    return null;
  } else if (elementType === 'checkbox' && !$(element).is(':checked')) {
    return null;
  }
  let value;
  if (hasAnInputChildren) {
    value = inputsChildren.val();
  } else {
    value = $(tag).val();
  }
  return value;
}

function _parseTags(tag, parsedTags, pluginInputs) {
  const obj = {}
  $(tag).find(pluginInputs).not('.templates *').each(function () {
    const tmp = _parsePluginOptions(this, parsedTags);
    if (!tmp) {
      return true;
    }
    let isArray = false;
    let key;
    const _pluginKeyAttribute = 'pluginKey';
    if ($(this).data(_pluginKeyAttribute)) {
      key = $(this).data(_pluginKeyAttribute);
    } else {
      key = $(this).attr('plugindataname');
    }
    const line = /^(.*)\[]$/;
    let lineRegex;
    if ((lineRegex = line.exec(key))) {
      key = lineRegex[1];
      isArray = true;
    }
    if (isArray) {
      if (obj[key]) {
        obj[key].push(tmp);
      } else {
        obj[key] = [tmp];
      }
    } else {
      obj[key] = tmp;
    }
  });
  return obj;
}

function _parsePluginOptions(tag, parsedTags) {
  if (parsedTags.indexOf(tag) > -1) {
    return null;
  }
  parsedTags.push(tag);
  const pluginInputs = '[plugindataname], [data-plugin-key]';
  const submitButton = '[type="submit"]';
  const inputsToIgnore = '.abtasty-ignored-input';
  const inputsChildren = $('form').find('input').not(submitButton).not(pluginInputs).not(inputsToIgnore);
  const hasAnInputChildren = inputsChildren.length === 1;
  const tagIsInput = $(tag).prop('tagName') === 'INPUT' || $(tag).prop('tagName') === 'TEXTAREA';
  const tagHasValue = ($(tag).val() && $(tag).val() !== '') || tagIsInput || hasAnInputChildren;
  if (tagHasValue) {
    return _parseTag(tag, hasAnInputChildren, inputsChildren);
  } 
    return _parseTags(tag, parsedTags, pluginInputs);
  
}

function _setupArrayOptions(data) {
  const key = data[0];
  const value = data[1];
  const keyForSelector = `${key  }[]`;
  let newElement;

  for (let i = 0; i < value.length; i++) {
    const $keySelector =
      $(`[plugindataname="${  keyForSelector  }"], [data-plugin-key="${  keyForSelector  }"]`)
        .not('.templates *');
    if (i === 0 && $keySelector.length > 0) {
      newElement = $keySelector;
    } else {
      newElement = _addElementToPluginForm(keyForSelector);
    }
    _setupPluginOptions(value[i], newElement);
  }
}

function _setupOption(key, value, element) {
  const pluginInputs = '[plugindataname], [data-plugin-key]';
  const submitButton = '[type="submit"]';
  let inputElement;
  const inputsChildren = $(element).find('input').not(submitButton).not(pluginInputs);

  if (inputsChildren.length > 0) {
    inputElement = inputsChildren;
  } else {
    inputElement =
      $(element)
        .find(`[plugindataname="${  key  }"], [data-plugin-key="${  key  }"]`);
  }

  // Fill in the inputs
  $(inputElement).each(function () {
    const inputType = $(this).attr('type');
    if (inputType === 'radio') {
      if ($(this).val() === value) {
        $(this).prop('checked', true);
      }
    } else if (inputType === 'checkbox') {
      if ($(this).val() === value) {
        $(this).prop('checked', true);
      }
    } else if (inputType !== 'file' &&
        // If the input is hidden,
        // the value is probably dynamic,
        // so don't fill in this input.
        inputType !== 'hidden'
      ) {
        $(this).val(value);
      }
  });
}

function _checkOptionType(key, value, element) {
  if (value instanceof Array) {
    _waitForIt('span[pluginPlaceFor]', _setupArrayOptions, [key, value]);
  } else if (typeof value === 'object') {
    for (const elem in value) {
      _setupOption(elem, value[elem], `[data-plugin-key="${  key  }"]`);
    }
  } else if (typeof value === 'string' /* || typeof value == "boolean" */) {
    _setupOption(key, value, element);
  }
}
