const JSONfn = require('json-fn');
// const { startSpinningAnimation } = require('../helpers');

const {
  $WEBVIEW__CONFIGFORM,
  $CONFIGFORM,
  $CONFIGFORM__TOGGLER,
  $INPUT__CONFIGFORM_DEVTOOLS,
} = require('../constants');

const HIDDEN = 'hidden';

// privates
function injectForm(formContent, isHtml, isReload) {
  $WEBVIEW__CONFIGFORM.send('setForm', JSONfn.stringify(formContent), isHtml, isReload);
}

function openDevTools() {
  $WEBVIEW__CONFIGFORM.openDevTools();
}

function reload() {
  $WEBVIEW__CONFIGFORM.reload();
}

function toggleVisibility() {
  $CONFIGFORM__TOGGLER.classList.toggle(HIDDEN);
  $CONFIGFORM.classList.toggle(HIDDEN);
}

module.exports = {
  injectForm,
  reload,
  toggleVisibility,
  openDevTools,
  // event listeners
  events: {
    click: {
      toggler: callback => $CONFIGFORM__TOGGLER.addEventListener('click', callback),
      devtools: callback => $INPUT__CONFIGFORM_DEVTOOLS.addEventListener('click', callback),
    },
    domready: callback => $WEBVIEW__CONFIGFORM.addEventListener('dom-ready', callback),
  },
};
