const {
  $WEBVIEW__WEBPAGE,
  $INPUT__WEBPAGE_DEVTOOLS,
  $BTN__WEBPAGE_PREV,
  $BTN__WEBPAGE_NEXT,
  $BTN__WEBPAGE_REFRESH,
  $INPUT__WEBPAGE_ROTATE_PORTRAIT,
  $INPUT__WEBPAGE_ROTATE_LANDSCAPE,
  $INPUT__WEBPAGE_URL,
  $SELECT__WEBPAGE_RESIZE,
  $INPUT__WEBPAGE_WIDTH,
  $INPUT__WEBPAGE_HEIGHT,
} = require('../constants');

module.exports = {
  electron: {
    onMessage: callback => $WEBVIEW__WEBPAGE.addEventListener('ipc-message', callback),
  },
  click: {
    devtoolsButton: callback => $INPUT__WEBPAGE_DEVTOOLS.addEventListener('click', callback),
    prevButton: callback => $BTN__WEBPAGE_PREV.addEventListener('click', callback),
    nextButton: callback => $BTN__WEBPAGE_NEXT.addEventListener('click', callback),
    refreshButton: callback => $BTN__WEBPAGE_REFRESH.addEventListener('click', callback),
    landscapeOrientation: callback =>
      $INPUT__WEBPAGE_ROTATE_LANDSCAPE.addEventListener('click', callback),
    portraitOrientation: callback =>
      $INPUT__WEBPAGE_ROTATE_PORTRAIT.addEventListener('click', callback),
  },
  change: {
    url: callback => $INPUT__WEBPAGE_URL.addEventListener('change', callback),
    deviceDropdown: callback => $SELECT__WEBPAGE_RESIZE.addEventListener('change', callback),
    widthInput: callback => $INPUT__WEBPAGE_WIDTH.addEventListener('change', callback),
    heightInput: callback => $INPUT__WEBPAGE_HEIGHT.addEventListener('change', callback),
  },
  resize: {
    webview: callback => $WEBVIEW__WEBPAGE.addEventListener('resize', callback),
  },
  domready: callback => $WEBVIEW__WEBPAGE.addEventListener('dom-ready', callback),
  failLoading: callback => $WEBVIEW__WEBPAGE.addEventListener('did-fail-load', callback),
};
